package gregapi.cover.covers;

import static gregapi.data.CS.T;
import gregapi.code.TagData;
import gregapi.cover.CoverData;
import gregapi.old.Textures;
import gregapi.render.BlockTextureDefault;
import gregapi.render.BlockTextureMulti;
import gregapi.render.ITexture;
import gregapi.tileentity.energy.ITileEntityEnergyDataCapacitor;
import gregapi.util.UT;

/**
 * @author Gregorius Techneticies
 */
public class CoverEnergyDisplay extends AbstractCoverAttachment {
	@Override
	public void onTickPost(byte aSide, CoverData aData, long aTimer, boolean aIsServerSide, boolean aReceivedBlockUpdate, boolean aReceivedInventoryUpdate) {
		if (aIsServerSide && aData.mTileEntity instanceof ITileEntityEnergyDataCapacitor && !((ITileEntityEnergyDataCapacitor)aData.mTileEntity).getEnergyCapacitorTypes(aSide).isEmpty()) {
			TagData tEnergyType = ((ITileEntityEnergyDataCapacitor)aData.mTileEntity).getEnergyCapacitorTypes(aSide).iterator().next();
			long tStored = ((ITileEntityEnergyDataCapacitor)aData.mTileEntity).getEnergyStored(tEnergyType, aSide), tCapacity = ((ITileEntityEnergyDataCapacitor)aData.mTileEntity).getEnergyCapacity(tEnergyType, aSide);
			aData.visual(aSide, (short)(tStored <= 0 || tCapacity <= 0 ? 0 : tStored >= tCapacity ? 10 : 9-(int)Math.max(0, Math.min(8, ((tCapacity-tStored)*9L) / tCapacity))));
		}
	}
	
	@Override public ITexture getCoverTextureSurface(byte aSide, CoverData aData) {return BlockTextureMulti.get(sTexturesBase, sTextures[(int)UT.Code.bind_(0, 10, aData.mVisuals[aSide])]);}
	@Override public ITexture getCoverTextureAttachment(byte aSide, CoverData aData, byte aTextureSide) {return aSide != aTextureSide ? sTextureBackground : BlockTextureMulti.get(sTextureBackground, getCoverTextureSurface(aSide, aData));}
	@Override public ITexture getCoverTextureHolder(byte aSide, CoverData aData, byte aTextureSide) {return sTextureBackground;}
	@Override public boolean needsVisualsSaved(byte aSide, CoverData aData) {return T;}
	
	public static final ITexture[] sTextures = new ITexture[] {
		  BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/0"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/1"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/2"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/3"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/4"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/5"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/6"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/7"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/8"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/9"), T)
		, BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/10"), T)
	};
	
	public static final ITexture sTexturesBase = BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/underlay"));
	public static final ITexture sTextureBackground = BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/energydisplay/base"));
}