package gregapi.fluid;

import static gregapi.data.CS.RES_PATH_BLOCK;
import gregapi.GT_API;
import net.minecraftforge.fluids.Fluid;

public class FluidGT extends Fluid implements Runnable {
	private final short[] mRGBa;
	
	public final String mTextureName;
	
	public FluidGT(String aName, String aTextureName, short[] aRGBa) {
		super(aName);
		mRGBa = aRGBa;
		mTextureName = aTextureName;
		if (GT_API.sBlockIconload != null) GT_API.sBlockIconload.add(this);
	}
	
    @Override
	public int getColor() {
        return (Math.max(0, Math.min(255, mRGBa[0])) << 16) | (Math.max(0, Math.min(255, mRGBa[1])) << 8) | Math.max(0, Math.min(255, mRGBa[2]));
    }
    
	@Override
	public void run() {
		setIcons(GT_API.sBlockIcons.registerIcon(RES_PATH_BLOCK + "fluids/fluid." + mTextureName));
	}
}